Subject: bug#60943: 28.2; ‘tramp-handle-file-regular-p’ misses symlinks

From: Greg Pfeil <[email-masked]>
Date: Fri, 20 Jan 2023 07:16:50 -0700

Ah, I see it’s right there in the docs even! I had just glanced at the impl, saw S_ISREG in there and assumed. Thanks for the clarification.

-- 
Sent from my iPhone

> On Jan 20, 2023, at 03:56, Michael Albinus <[email-masked]> wrote:
> 
> Greg Pfeil <[email-masked]> writes:
> 
> Hi Greg,
> 
>> I think sockets (where the 0th char is ?s) are also considered regular
>> files. Also, I think that patch checks whether the truename is a
>> regular file, but I believe /all/ symlinks are considered regular.
> 
> No, neither sockets nor symlinks to directories count as regular
> files. See the Elisp manual (info "(elisp) Kinds of Files")
> 
> A socket is an "other I/O device" according to the description. And
> symlinks are regular files only, if they point to a regular file.
> 
>> It just changes the equality check to check for the set of valid
>> values. If we had the mode as a number, we could just check the one
>> bit for regular files (which I think is what ‘file-regular-p’ does).
> 
> You can always check yourself in Emacs with a local file. For example,
> if you have a socket like "/run/user/1000/bus":
> 
> --8<---------------cut here---------------start------------->8---
> (file-exists-p (concat (getenv "XDG_RUNTIME_DIR") "/bus"))
> => t
> 
> (file-attribute-modes (file-attributes (concat (getenv "XDG_RUNTIME_DIR") "/bus")))
> => "srw-rw-rw-"
> 
> (file-regular-p (concat (getenv "XDG_RUNTIME_DIR") "/bus"))
> => nil
> --8<---------------cut here---------------end--------------->8---
> 
> Or
> 
> --8<---------------cut here---------------start------------->8---
> (make-directory "/tmp/foo")
> (file-attribute-modes (file-attributes "/tmp/foo"))
> => "drwxr-xr-x"
> 
> (make-symbolic-link "/tmp/foo" "/tmp/bar")
> (file-attribute-modes (file-attributes "/tmp/bar"))
> => "lrwxrwxrwx"
> 
> (file-regular-p "/tmp/bar")
> => nil
> --8<---------------cut here---------------end--------------->8---
> 
> for symbolic links.
> 
> Best regards, Michael.
>